/**
 */
package library;

import org.eclipse.emf.ecore.EAttribute;
import org.eclipse.emf.ecore.EClass;
import org.eclipse.emf.ecore.EPackage;
import org.eclipse.emf.ecore.EReference;

/**
 * <!-- begin-user-doc -->
 * The <b>Package</b> for the model.
 * It contains accessors for the meta objects to represent
 * <ul>
 *   <li>each class,</li>
 *   <li>each feature of each class,</li>
 *   <li>each operation of each class,</li>
 *   <li>each enum,</li>
 *   <li>and each data type</li>
 * </ul>
 * <!-- end-user-doc -->
 * @see library.LibraryFactory
 * @model kind="package"
 * @generated
 */
public interface LibraryPackage extends EPackage {
    /**
     * The package name.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     */
    String eNAME = "library";

    /**
     * The package namespace URI.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     */
    String eNS_URI = "http://www.centralesupelec.fr/test/library";

    /**
     * The package namespace name.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     */
    String eNS_PREFIX = "lib";

    /**
     * The singleton instance of the package.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     */
    LibraryPackage eINSTANCE = library.impl.LibraryPackageImpl.init();

    /**
     * The meta object id for the '{@link library.impl.LibraryImpl <em>Library</em>}' class.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @see library.impl.LibraryImpl
     * @see library.impl.LibraryPackageImpl#getLibrary()
     * @generated
     */
    int LIBRARY = 0;

    /**
     * The feature id for the '<em><b>Books</b></em>' containment reference list.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int LIBRARY__BOOKS = 0;

    /**
     * The feature id for the '<em><b>Authors</b></em>' containment reference list.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int LIBRARY__AUTHORS = 1;

    /**
     * The number of structural features of the '<em>Library</em>' class.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int LIBRARY_FEATURE_COUNT = 2;

    /**
     * The number of operations of the '<em>Library</em>' class.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int LIBRARY_OPERATION_COUNT = 0;

    /**
     * The meta object id for the '{@link library.impl.BookImpl <em>Book</em>}' class.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @see library.impl.BookImpl
     * @see library.impl.LibraryPackageImpl#getBook()
     * @generated
     */
    int BOOK = 1;

    /**
     * The feature id for the '<em><b>Title</b></em>' attribute.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int BOOK__TITLE = 0;

    /**
     * The feature id for the '<em><b>Publication Date</b></em>' attribute.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int BOOK__PUBLICATION_DATE = 1;

    /**
     * The feature id for the '<em><b>Acquisition Date</b></em>' attribute.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int BOOK__ACQUISITION_DATE = 2;

    /**
     * The feature id for the '<em><b>Author</b></em>' reference.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int BOOK__AUTHOR = 3;

    /**
     * The number of structural features of the '<em>Book</em>' class.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int BOOK_FEATURE_COUNT = 4;

    /**
     * The number of operations of the '<em>Book</em>' class.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int BOOK_OPERATION_COUNT = 0;

    /**
     * The meta object id for the '{@link library.impl.AuthorImpl <em>Author</em>}' class.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @see library.impl.AuthorImpl
     * @see library.impl.LibraryPackageImpl#getAuthor()
     * @generated
     */
    int AUTHOR = 2;

    /**
     * The feature id for the '<em><b>First Name</b></em>' attribute.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int AUTHOR__FIRST_NAME = 0;

    /**
     * The feature id for the '<em><b>Last Name</b></em>' attribute.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int AUTHOR__LAST_NAME = 1;

    /**
     * The feature id for the '<em><b>Birth Date</b></em>' attribute.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int AUTHOR__BIRTH_DATE = 2;

    /**
     * The feature id for the '<em><b>Books</b></em>' reference list.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int AUTHOR__BOOKS = 3;

    /**
     * The number of structural features of the '<em>Author</em>' class.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int AUTHOR_FEATURE_COUNT = 4;

    /**
     * The number of operations of the '<em>Author</em>' class.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int AUTHOR_OPERATION_COUNT = 0;


    /**
     * Returns the meta object for class '{@link library.Library <em>Library</em>}'.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @return the meta object for class '<em>Library</em>'.
     * @see library.Library
     * @generated
     */
    EClass getLibrary();

    /**
     * Returns the meta object for the containment reference list '{@link library.Library#getBooks <em>Books</em>}'.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @return the meta object for the containment reference list '<em>Books</em>'.
     * @see library.Library#getBooks()
     * @see #getLibrary()
     * @generated
     */
    EReference getLibrary_Books();

    /**
     * Returns the meta object for the containment reference list '{@link library.Library#getAuthors <em>Authors</em>}'.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @return the meta object for the containment reference list '<em>Authors</em>'.
     * @see library.Library#getAuthors()
     * @see #getLibrary()
     * @generated
     */
    EReference getLibrary_Authors();

    /**
     * Returns the meta object for class '{@link library.Book <em>Book</em>}'.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @return the meta object for class '<em>Book</em>'.
     * @see library.Book
     * @generated
     */
    EClass getBook();

    /**
     * Returns the meta object for the attribute '{@link library.Book#getTitle <em>Title</em>}'.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @return the meta object for the attribute '<em>Title</em>'.
     * @see library.Book#getTitle()
     * @see #getBook()
     * @generated
     */
    EAttribute getBook_Title();

    /**
     * Returns the meta object for the attribute '{@link library.Book#getPublicationDate <em>Publication Date</em>}'.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @return the meta object for the attribute '<em>Publication Date</em>'.
     * @see library.Book#getPublicationDate()
     * @see #getBook()
     * @generated
     */
    EAttribute getBook_PublicationDate();

    /**
     * Returns the meta object for the attribute '{@link library.Book#getAcquisitionDate <em>Acquisition Date</em>}'.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @return the meta object for the attribute '<em>Acquisition Date</em>'.
     * @see library.Book#getAcquisitionDate()
     * @see #getBook()
     * @generated
     */
    EAttribute getBook_AcquisitionDate();

    /**
     * Returns the meta object for the reference '{@link library.Book#getAuthor <em>Author</em>}'.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @return the meta object for the reference '<em>Author</em>'.
     * @see library.Book#getAuthor()
     * @see #getBook()
     * @generated
     */
    EReference getBook_Author();

    /**
     * Returns the meta object for class '{@link library.Author <em>Author</em>}'.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @return the meta object for class '<em>Author</em>'.
     * @see library.Author
     * @generated
     */
    EClass getAuthor();

    /**
     * Returns the meta object for the attribute '{@link library.Author#getFirstName <em>First Name</em>}'.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @return the meta object for the attribute '<em>First Name</em>'.
     * @see library.Author#getFirstName()
     * @see #getAuthor()
     * @generated
     */
    EAttribute getAuthor_FirstName();

    /**
     * Returns the meta object for the attribute '{@link library.Author#getLastName <em>Last Name</em>}'.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @return the meta object for the attribute '<em>Last Name</em>'.
     * @see library.Author#getLastName()
     * @see #getAuthor()
     * @generated
     */
    EAttribute getAuthor_LastName();

    /**
     * Returns the meta object for the attribute '{@link library.Author#getBirthDate <em>Birth Date</em>}'.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @return the meta object for the attribute '<em>Birth Date</em>'.
     * @see library.Author#getBirthDate()
     * @see #getAuthor()
     * @generated
     */
    EAttribute getAuthor_BirthDate();

    /**
     * Returns the meta object for the reference list '{@link library.Author#getBooks <em>Books</em>}'.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @return the meta object for the reference list '<em>Books</em>'.
     * @see library.Author#getBooks()
     * @see #getAuthor()
     * @generated
     */
    EReference getAuthor_Books();

    /**
     * Returns the factory that creates the instances of the model.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @return the factory that creates the instances of the model.
     * @generated
     */
    LibraryFactory getLibraryFactory();

    /**
     * <!-- begin-user-doc -->
     * Defines literals for the meta objects that represent
     * <ul>
     *   <li>each class,</li>
     *   <li>each feature of each class,</li>
     *   <li>each operation of each class,</li>
     *   <li>each enum,</li>
     *   <li>and each data type</li>
     * </ul>
     * <!-- end-user-doc -->
     * @generated
     */
    interface Literals {
        /**
         * The meta object literal for the '{@link library.impl.LibraryImpl <em>Library</em>}' class.
         * <!-- begin-user-doc -->
         * <!-- end-user-doc -->
         * @see library.impl.LibraryImpl
         * @see library.impl.LibraryPackageImpl#getLibrary()
         * @generated
         */
        EClass LIBRARY = eINSTANCE.getLibrary();

        /**
         * The meta object literal for the '<em><b>Books</b></em>' containment reference list feature.
         * <!-- begin-user-doc -->
         * <!-- end-user-doc -->
         * @generated
         */
        EReference LIBRARY__BOOKS = eINSTANCE.getLibrary_Books();

        /**
         * The meta object literal for the '<em><b>Authors</b></em>' containment reference list feature.
         * <!-- begin-user-doc -->
         * <!-- end-user-doc -->
         * @generated
         */
        EReference LIBRARY__AUTHORS = eINSTANCE.getLibrary_Authors();

        /**
         * The meta object literal for the '{@link library.impl.BookImpl <em>Book</em>}' class.
         * <!-- begin-user-doc -->
         * <!-- end-user-doc -->
         * @see library.impl.BookImpl
         * @see library.impl.LibraryPackageImpl#getBook()
         * @generated
         */
        EClass BOOK = eINSTANCE.getBook();

        /**
         * The meta object literal for the '<em><b>Title</b></em>' attribute feature.
         * <!-- begin-user-doc -->
         * <!-- end-user-doc -->
         * @generated
         */
        EAttribute BOOK__TITLE = eINSTANCE.getBook_Title();

        /**
         * The meta object literal for the '<em><b>Publication Date</b></em>' attribute feature.
         * <!-- begin-user-doc -->
         * <!-- end-user-doc -->
         * @generated
         */
        EAttribute BOOK__PUBLICATION_DATE = eINSTANCE.getBook_PublicationDate();

        /**
         * The meta object literal for the '<em><b>Acquisition Date</b></em>' attribute feature.
         * <!-- begin-user-doc -->
         * <!-- end-user-doc -->
         * @generated
         */
        EAttribute BOOK__ACQUISITION_DATE = eINSTANCE.getBook_AcquisitionDate();

        /**
         * The meta object literal for the '<em><b>Author</b></em>' reference feature.
         * <!-- begin-user-doc -->
         * <!-- end-user-doc -->
         * @generated
         */
        EReference BOOK__AUTHOR = eINSTANCE.getBook_Author();

        /**
         * The meta object literal for the '{@link library.impl.AuthorImpl <em>Author</em>}' class.
         * <!-- begin-user-doc -->
         * <!-- end-user-doc -->
         * @see library.impl.AuthorImpl
         * @see library.impl.LibraryPackageImpl#getAuthor()
         * @generated
         */
        EClass AUTHOR = eINSTANCE.getAuthor();

        /**
         * The meta object literal for the '<em><b>First Name</b></em>' attribute feature.
         * <!-- begin-user-doc -->
         * <!-- end-user-doc -->
         * @generated
         */
        EAttribute AUTHOR__FIRST_NAME = eINSTANCE.getAuthor_FirstName();

        /**
         * The meta object literal for the '<em><b>Last Name</b></em>' attribute feature.
         * <!-- begin-user-doc -->
         * <!-- end-user-doc -->
         * @generated
         */
        EAttribute AUTHOR__LAST_NAME = eINSTANCE.getAuthor_LastName();

        /**
         * The meta object literal for the '<em><b>Birth Date</b></em>' attribute feature.
         * <!-- begin-user-doc -->
         * <!-- end-user-doc -->
         * @generated
         */
        EAttribute AUTHOR__BIRTH_DATE = eINSTANCE.getAuthor_BirthDate();

        /**
         * The meta object literal for the '<em><b>Books</b></em>' reference list feature.
         * <!-- begin-user-doc -->
         * <!-- end-user-doc -->
         * @generated
         */
        EReference AUTHOR__BOOKS = eINSTANCE.getAuthor_Books();

    }

} //LibraryPackage
